<?php
   

   /*
 
     Oscommerce Plimus payment module
     ---------------------------------
     Author: chaouch salah
     contact: chaouch.salah@gmail.con
     http://www.rankhat.com

    */



    class plimus {
        var $code, $title, $description, $enabled;

        // class constructor
        function plimus() {
            global $order,$test;
            $subdomain="www";
            $this->code = 'plimus';
            $this->title = MODULE_PAYMENT_PLIMUS_TEXT_TITLE;
            $this->description = MODULE_PAYMENT_PLIMUS_TEXT_DESCRIPTION;
            $this->sort_order = MODULE_PAYMENT_PLIMUS_SORT_ORDER;
            $this->enabled = ((MODULE_PAYMENT_PLIMUS_STATUS == 'True') ? true : false);
            $this->use_subdomain = ((MODULE_PAYMENT_PAYMENT_PLIMUS_USEDOMAIN == 'True') ? true : false);
            $nodemo = ((MODULE_PAYMENT_PLIMUS_TESTMODE == 'Production') ? $test='N' : $test='Y');
            $this->cid = MODULE_PAYMENT_PLIMUS_CONTRACTID;

            if ((int)MODULE_PAYMENT_PLIMUS_ORDER_STATUS_ID > 0) {
                $this->order_status = MODULE_PAYMENT_PLIMUS_ORDER_STATUS_ID;
            }

            if (is_object($order)) $this->update_status();
             if ($this->use_subdomain == true) $subdomain=MODULE_PAYMENT_PLIMUS_SUBDOMAIN; 
            
            $this->form_action_url = "https://$subdomain.plimus.com/jsp/buynow.jsp?contractId=$this->cid";
         }

        // class methods
        function update_status() {
            global $order;

            if (($this->enabled == true) && ((int)MODULE_PAYMENT_PLIMUS_ZONE > 0) ) {
                $check_flag = false;
                $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_PLIMUS_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
                while ($check = tep_db_fetch_array($check_query)) {
                    if ($check['zone_id'] < 1) {
                        $check_flag = true;
                        break;
                    } elseif ($check['zone_id'] == $order->billing['zone_id']) {
                        $check_flag = true;
                        break;
                    }
                }

                if ($check_flag == false) {
                    $this->enabled = false;
                }
            }
        }

        function javascript_validation() {
            return false;
        }

        function selection() {  
            $img_plimus = DIR_WS_MODULES . 'payment/plimus/images/plimus.jpg';
            $plimus_txt = sprintf(MODULE_PAYMENT_PLIMUS_CC_TEXT,
                                tep_image($img_plimus,' Plimus ','','','align=ABSMIDDLE')
                                );
            $fields[] = array('title' => '', //MODULE_PAYMENT_PLIMUS_TEXT_TITLE,
                              'field' => '' . $plimus_txt . '');
            return array('id' => $this->code,
                         'module' => $this->title,
                         'fields' => $fields);
        }

        function pre_confirmation_check() {
            return false;
        }

        function confirmation() {
            global $HTTP_POST_VARS;
            $title = $this->title;
            $confirmation = array('title' => $title);
            return $confirmation;
        }




////////////////////////////////////////////////////////////////////////////////////////////////////
function process_button() {
            global $HTTP_POST_VARS, $order, $currency, $currencies, $test;
            global $languages_id;

            $cOrderTotal = $order->info['total'];

           

            $process_button_string = '';
            $process_button_string .= tep_draw_hidden_field('overridePrice', number_format($cOrderTotal, 2, '.', '')) .
            
            tep_draw_hidden_field('firstName', $order->customer['firstname']) .
            tep_draw_hidden_field('lastName', $order->customer['lastname']) .
            tep_draw_hidden_field('address1', $order->customer['street_address']) .
            tep_draw_hidden_field('city', $order->customer['city']) .
            tep_draw_hidden_field('state', $order->customer['state']) .
            tep_draw_hidden_field('zipCode', $order->customer['postcode']) .
            tep_draw_hidden_field('country', $order->customer['country']['title']) .
            tep_draw_hidden_field('email', $order->customer['email_address']) .
            tep_draw_hidden_field('workPhone', $order->customer['telephone']) .
            tep_draw_hidden_field('currency', $currency) .
            tep_draw_hidden_field('bCur', $currency) .
            tep_draw_hidden_field('paymentMethod', 'step2') .
            tep_draw_hidden_field('showAlternativeProductName', 'N') .
            tep_draw_hidden_field('testMode',$test);
            return $process_button_string;
        }
////////////////////////////////////////////////////////////////////////////////////////////////////////////


        function before_process() {
      
            return false;

        }

        function after_process() {
            return false;
        }

        function get_error() {
            global $HTTP_GET_VARS;

            $error = array('title' => MODULE_PAYMENT_PLIMUS_TEXT_ERROR,
                'error' => stripslashes(urldecode($HTTP_GET_VARS['error'])));

            return $error;
        }

        function check() {
            if (!isset($this->_check)) {
                $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PLIMUS_STATUS'");
                $this->_check = tep_db_num_rows($check_query);
            }
            return $this->_check;
        }

        function install() {
            tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Plimus Module', 'MODULE_PAYMENT_PLIMUS_STATUS', 'True', 'Do you want to accept Plimus payments?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
            tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Plimus Contractid Number', 'MODULE_PAYMENT_PLIMUS_CONTRACTID', '2058586', 'Your Plimus Contractid Number', '6', '2', now())");
            tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Mode', 'MODULE_PAYMENT_PLIMUS_TESTMODE', 'Production', 'Transaction mode used for the Plimus service', '6', '3', 'tep_cfg_select_option(array(\'Production\', \'Test\'), ', now())");
            tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_PLIMUS_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '5', now())");
            tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_PLIMUS_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '6', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
            tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_PLIMUS_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '7', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
            tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Use Subdomain', 'MODULE_PAYMENT_PAYMENT_PLIMUS_USEDOMAIN', 'False', 'Do you have a registred Plimus subdomain ?', '6', '8', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
            tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Subdomain', 'MODULE_PAYMENT_PLIMUS_SUBDOMAIN', 'www', 'Enter your subdomain name here', '6', '9', now())");
        }

        function remove() {
            tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
        }

        function keys() {
            return array('MODULE_PAYMENT_PLIMUS_STATUS', 'MODULE_PAYMENT_PLIMUS_CONTRACTID', 'MODULE_PAYMENT_PLIMUS_TESTMODE', 'MODULE_PAYMENT_PLIMUS_ZONE', 'MODULE_PAYMENT_PLIMUS_ORDER_STATUS_ID', 'MODULE_PAYMENT_PLIMUS_SORT_ORDER','MODULE_PAYMENT_PAYMENT_PLIMUS_USEDOMAIN', 'MODULE_PAYMENT_PLIMUS_SUBDOMAIN');
        }
    }
?>